#!/usr/bin/env python
# coding: utf-8

# In[416]:


## Reading g-code file line by line and placing them in the "lines"

global file_to_convert 

file_to_convert = "CFFFP_xyzCalibration_cube.gcode"

f  = open(file_to_convert, "r+")
f0 = f.readlines()

lines = []
lines_original = []

for x in f0:
    
    lines_original.append(x)
    
    x = x.rstrip()
    lines.append(x)

print(len(lines))


# In[417]:



## We will now split the lines into every x move, every y move, every z move, and their corresponding line numbers.
## We will then determine which lines contain direction changes, and we will place backlash compensation moves 
## before each direction change.

original_length = len(lines)

x_lines = []
y_lines = []
z_lines = []
ijk =[i,j,k]

x_moves = []
y_moves = []
z_moves = []

x_moves_tmp = []
y_moves_tmp = []
z_moves_tmp = []

x_dir_change = []
y_dir_change = []
z_dir_change = []

x_backlash = 0.81 ##(in mm)
y_backlash = 2.82 ##(in mm)
z_backlash = 0

x_lines_added = 0
y_lines_added = 0
z_lines_added = 0




######################################################################################
######################################################################################

##
## This section determines and inserts backlash compensation moves. 
## This is the bulk of the program.
##

#### Starting with X

for n in range(0,len(lines)): ## Putting lines containing X's in a seperate list.
    
    i = lines[n].split('X') 
    
    if(len(i)>1): ## Storing all lines containing an X and its original line number
        
        x_lines.append([i,n])
        

        
    
    
for f in x_lines: ## Filtering x_lines for just move commands
            
    if(('G1' in f[0][0]) or ('G0' in f[0][0])): 
        
        x_moves.append(f)


        
    
    
for i in range(0,len(x_moves)-1): ## Removing moves with 0 difference in the X direction
    
    tmp1 = float(x_moves[i][0][1].split(' ')[0])
    tmp2 = float(x_moves[i+1][0][1].split(' ')[0])
    
    if(tmp2-tmp1 != 0.0):
        
        x_moves_tmp.append(x_moves[i])
        
x_moves = x_moves_tmp ## Setting x_moves to x_moves_tmp
        

    
    
    
for i in range(1,len(x_moves)-1): ## determining which lines have direction changes.
    
    tmp1 = float(x_moves[i-1][0][1].split(' ')[0])
    tmp2 = float(x_moves[i][0][1].split(' ')[0])
    tmp3 = float(x_moves[i+1][0][1].split(' ')[0])

    dir1 = tmp2-tmp1
    dir2 = tmp3-tmp2
    
    ##
    ## Here is where we insert compensation moves.
    ##
    
    if(dir1*dir2 <= 0.0 and str(dir1*dir2) != '0.0'): ## if the direction between adjacent moves is disimilar, there is a direction change.
                
        ##print("X DIRECTION CHANGE AT:", (x_moves[i][1]))
        
        x_dir_change.append(int(x_moves[i][1])) ## Storing list of direction changes with their original lines.
        
        adjusted_line = int(x_moves[i][1]) + 1 + x_lines_added ## adjusting where to place line given how many have been placed so far.
        
        ##print(x_lines_added)
        ##print(adjusted_line)

        
        x_lines_added += 2;
        
        
        if(dir2<0): ## The compensation move must be in the direction of dir2.
            comp_dir = -1
        else: 
            comp_dir = 1

        
        ## building move instruction
        
        move = 'G1 X' + str(float(x_moves[i][0][1].split(' ')[0]) + x_backlash*comp_dir)
        pos_reset = 'G92 X' + str(float(x_moves[i][0][1].split(' ')[0])) 
    
        
        ## Finally inserting compensation moves.
        
        lines.insert(adjusted_line, move)
        lines.insert(adjusted_line+1, pos_reset)
        
## Doulbe checking lengths.
        
x_comp_len = len(lines)

if(x_comp_len != (original_length + x_lines_added)):
    
    print("Lengths dont match, something went wrong.")


# In[418]:


print(x_lines_added)


# In[419]:



original_length = len(lines)

x_lines = []
y_lines = []
z_lines = []
ijk =[i,j,k]

x_moves = []
y_moves = []
z_moves = []

x_moves_tmp = []
y_moves_tmp = []
z_moves_tmp = []

x_dir_change = []
y_dir_change = []
z_dir_change = []

x_backlash = 0.81 ##(in mm)
y_backlash = 2.82 ##(in mm)
z_backlash = 0

x_lines_added = 0
y_lines_added = 0
z_lines_added = 0

######################################################################################
######################################################################################

##
## This section determines and inserts backlash compensation moves. 
## This is the bulk of the program.
##

#### Now doing Y

for n in range(0,len(lines)): ## Putting lines containing Y's in a seperate list.
    
    i = lines[n].split('Y') 
    
    if(len(i)>1): ## Storing all lines containing a Y and its original line number
        
        y_lines.append([i,n])
        

        
    
    
for f in y_lines: ## Filtering x_lines for just move commands
            
    if(('G1' in f[0][0]) or ('G0' in f[0][0])): 
        
        y_moves.append(f)


        
    
    
for i in range(0,len(y_moves)-1): ## Removing moves with 0 difference in the X direction
    
    tmp1 = float(y_moves[i][0][1].split(' ')[0])
    tmp2 = float(y_moves[i+1][0][1].split(' ')[0])
    
    if(tmp2-tmp1 != 0.0):
        
        y_moves_tmp.append(y_moves[i])
        
y_moves = y_moves_tmp ## Setting y_moves to y_moves_tmp
        

    
    
    
for i in range(1,len(y_moves)-1): ## determining which lines have direction changes.
    
    tmp1 = float(y_moves[i-1][0][1].split(' ')[0])
    tmp2 = float(y_moves[i][0][1].split(' ')[0])
    tmp3 = float(y_moves[i+1][0][1].split(' ')[0])

    dir1 = tmp2-tmp1
    dir2 = tmp3-tmp2
    
    ##
    ## Here is where we insert compensation moves.
    ##
    
    if(dir1*dir2 <= 0.0 and str(dir1*dir2) != '0.0'): ## if the direction between adjacent moves is disimilar, there is a direction change.
                
        ##print("Y DIRECTION CHANGE AT:", (y_moves[i][1]))
        
        y_dir_change.append(int(y_moves[i][1])) ## Storing list of direction changes with their original lines.
        
        adjusted_line = int(y_moves[i][1]) + 1 + y_lines_added ## adjusting where to place line given how many have been placed so far.
        
        ##print(x_lines_added)
        ##print(adjusted_line)

        
        y_lines_added += 2;
        
        
        if(dir2<0): ## The compensation move must be in the direction of dir2.
            comp_dir = -1
        else: 
            comp_dir = 1

        
        ## building move instruction
        
        move = 'G1 Y' + str(float(y_moves[i][0][1].split(' ')[0]) + y_backlash*comp_dir)
        pos_reset = 'G92 Y' + str(float(y_moves[i][0][1].split(' ')[0])) 
    
        
        ## Finally inserting compensation moves.
        
        lines.insert(adjusted_line, move)
        lines.insert(adjusted_line+1, pos_reset)
        
## Doulbe checking lengths.
        
y_comp_len = len(lines)

if(y_comp_len != (original_length + y_lines_added)):
    
    print("Lengths dont match, something went wrong.")
    
print(len(lines))
print(y_lines_added)


# In[420]:



original_length = len(lines)

x_lines = []
y_lines = []
z_lines = []
ijk =[i,j,k]

x_moves = []
y_moves = []
z_moves = []

x_moves_tmp = []
y_moves_tmp = []
z_moves_tmp = []

x_dir_change = []
y_dir_change = []
z_dir_change = []

x_backlash = 0.81 ##(in mm)
y_backlash = 2.82 ##(in mm)
z_backlash = 0

x_lines_added = 0
y_lines_added = 0
z_lines_added = 0

######################################################################################
######################################################################################

##
## This section determines and inserts backlash compensation moves. 
## This is the bulk of the program.
##

#### Now doing Z

for n in range(0,len(lines)): ## Putting lines containing Y's in a seperate list.
    
    i = lines[n].split('Z') 
    
    if(len(i)>1): ## Storing all lines containing an Y and its original line number
        
        z_lines.append([i,n])
        

        
    
    
for f in z_lines: ## Filtering z_lines for just move commands
            
    if(('G1' in f[0][0]) or ('G0' in f[0][0])): 
        
        z_moves.append(f)


        
    
    
for i in range(0,len(z_moves)-1): ## Removing moves with 0 difference in the X direction
    
    tmp1 = float(z_moves[i][0][1].split(' ')[0])
    tmp2 = float(z_moves[i+1][0][1].split(' ')[0])
    
    if(tmp2-tmp1 != 0.0):
        
        z_moves_tmp.append(z_moves[i])
        
z_moves = z_moves_tmp ## Setting z_moves to z_moves_tmp
        

    
    
    
for i in range(1,len(z_moves)-1): ## determining which lines have direction changes.
    
    tmp1 = float(z_moves[i-1][0][1].split(' ')[0])
    tmp2 = float(z_moves[i][0][1].split(' ')[0])
    tmp3 = float(z_moves[i+1][0][1].split(' ')[0])

    dir1 = tmp2-tmp1
    dir2 = tmp3-tmp2
    
    ##
    ## Here is where we insert compensation moves.
    ##
    
    if(dir1*dir2 <= 0.0 and str(dir1*dir2) != '0.0'): ## if the direction between adjacent moves is disimilar, there is a direction change.
                
        ##print("Z DIRECTION CHANGE AT:", (z_moves[i][1]))
        
        z_dir_change.append(int(z_moves[i][1])) ## Storing list of direction changes with their original lines.
        
        adjusted_line = int(z_moves[i][1]) + 1 + z_lines_added ## adjusting where to place line given how many have been placed so far.
        
        ##print(x_lines_added)
        ##print(adjusted_line)

        
        z_lines_added += 2;
        
        
        if(dir2<0): ## The compensation move must be in the direction of dir2.
            comp_dir = -1
        else: 
            comp_dir = 1

        
        ## building move instruction
        
        move = 'G1 Z' + str(float(z_moves[i][0][1].split(' ')[0]) + z_backlash*comp_dir)
        pos_reset = 'G92 Z' + str(float(z_moves[i][0][1].split(' ')[0])) 
    
        
        ## Finally inserting compensation moves.
        
        lines.insert(adjusted_line, move)
        lines.insert(adjusted_line+1, pos_reset)
        
## Doulbe checking lengths.
        
z_comp_len = len(lines)

if(z_comp_len != (original_length + z_lines_added)):
    
    print("Lengths dont match, something went wrong.")
    
print(len(lines))
print(z_lines_added)


# In[368]:





# In[422]:


## Writing modified lines to a new file.

new_file = str(file_to_convert.split('.')[0]+'_compensated')+'.'+file_to_convert.split('.')[1]

fn  = open(new_file, "w+")

for x in lines:
    
    fn.write(x+'\n')
    
fn.close()
    


# In[ ]:




